//* Pour une mesure de sécurité en plus pour le processeur
#ifndef __FILE_H
#define __FILE_H

#include "base.h"
#define MAX 1000

//* Définition d'une file
//* On considère notre objet étant un Nat
//* Implantation contigue et prog par mutation
//* Simulation du passage par addresse;

typedef struct StrFile{
    Nat valeur;
    struct StrFile *suivant;
}strFile, *file;

//* Prototypes

//* Création d'une file vide;
file fileNouv();

//* Ajouter en queue un élément
file ajoutEnQueue(file laFile, Nat x);

//* Test de vacuité
Bool estFileVide(file laFile);

//* Retourne la tête de la file
Nat teteFile(file laFile);

//* Longueur de la file
Nat longeurFile(file laFile);

//* Supprime l'élément en tête
file SupprimeTete(file LaFile);

#endif
