#include <stdio.h>
#include <stdlib.h>
#include <math.h>


// Converti un tableau de bit en decimal
int binaryToDecimalPuissancePositive(int *t,int sizet){
    int numberInDecimal = 0;
    for(int i = 0 ; i  < sizet; i++){
        numberInDecimal += t[i] << sizet - 1 - i ;
    }

    return numberInDecimal;
}

float binaryToDecimalPuissanceNegative(int *t,int sizet){
    float numberInDecimal = 0.0;
    for(int i = 0 ; i  < sizet; i++){
        printf("t[%d] = %d    ", i, t[i]);
        numberInDecimal += pow(t[i],-(i+1)) ;
    }

    return numberInDecimal;
}

// Prend la valeur de l'octet d'exposant converti en decimal
//* et retourne l'exposant
int exposant(int exposantParExces){
    return exposantParExces - 127;
}

void deplaceVirgule(int *tab, int exposant){
    int temp = 0;
    for(int i = 1 ; i < exposant + 1 ; i++){
        temp = tab[i];
        tab[i] = tab[i+1];
        tab[i+1] = temp;
    }
}

//* On recupère la partie entière du nombre denormalisé
int partieEntiereDecimaleNbrDenormalise(int *nombreDenormalise, int* partieEntiere, int* partieDecimale){
    int i = 0 ; 
    int taillePartieEntiere = 0;
    while(nombreDenormalise[i] != 44){
        partieEntiere[i] = nombreDenormalise[i];
        i++;
    }

    taillePartieEntiere = i;
    i = i + 1;

    for(int j = 0 ; i < 25 ; i++, j++){
        partieDecimale[j] = nombreDenormalise[i];
    }

    //* Connaissant la taille de la partie entière, on peut retrouver la taille 
    //* de l'autre partie, en utilisant la formule suivante : 
    //* taillePartieEntiere + taillePartieDecimale + 1 = 25 =>
    //* taillePartieDecimale = 25 - (taillePartieEntiere + 1)
    return taillePartieEntiere;
}

void denormalise(int *arrayOfBits, int* nombreDenormalise){

    int *octetPourExposant = malloc(sizeof(int)*8);
    int E,e;

    for(int j = 0 , i = 1; i < 9; i++, j++){
        octetPourExposant[j] = arrayOfBits[i];
    }

    E = binaryToDecimalPuissancePositive(octetPourExposant, 8);
    e = exposant(E);
    



    nombreDenormalise[0] = 1;
    nombreDenormalise[1] = 44;

    for(int i = 9 , j = 2 ; i < 32 ; i++, j++){
        nombreDenormalise[j] = arrayOfBits[i];
    }

    
    if(exposant > 0){
        deplaceVirgule(nombreDenormalise, e);
    }
    // for(int i = 0 ; i < 25; i++){
    //     printf("%d  ", nombreDenormalise[i]);
    // }
    printf("\n");
}


void convert(int *arrayOfBits, int length){
    char sign = ' ';

    int partieEntiere[13];
    int partieDecimale[30];
    int taillePartieEntiere;
    int taillePartieDecimale;

    int *nombreDenormalise = malloc(sizeof(int)*25);
    
    if(arrayOfBits[0] == 1){
        sign = '-';
    }

    denormalise(arrayOfBits, nombreDenormalise);


    taillePartieEntiere = partieEntiereDecimaleNbrDenormalise(nombreDenormalise, partieEntiere, partieDecimale);
    taillePartieDecimale = 25 - (taillePartieEntiere + 1);
    printf("La taille = %d\n", taillePartieEntiere);
    printf("entiere = %d\n", binaryToDecimalPuissancePositive(partieEntiere, taillePartieEntiere));
    printf("decimale = %f\n", binaryToDecimalPuissanceNegative(partieDecimale, taillePartieDecimale));



    for(int i = 0 ; i < 25; i++){
        printf("%d  ", nombreDenormalise[i]);
    }
    printf("\n");

}

int main(){
    // int t[8] = {1,0,0,0,0,1,0,1};
    int nombreCodeEnIEEE[32] = {0, 1, 0, 0, 0, 0, 1, 0, 1,  1, 0, 1, 0, 1, 0,
                                0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                0, 0};
    // int u[7] = {0};
    // int nombreDenormalise[25];

    // printf("%d\n", binaryToDecimal(t, 8));
    // printf("%d\n",',');

    // denormalise(nombreCodeEnIEEE, nombreDenormalise);

    convert(nombreCodeEnIEEE, 32);




    return 0;
}