#include <stdio.h>
#include "gestionDeStock.h"

void afficherLeStock(stock leStock){
    printf("{\n");
    for(int i = 0 ; i < MAX ; i++ ){
        if(leStock[i].ref != 0){
            printf("  {\n");
            printf("     Reference : %d,\n", leStock[i].ref);
            printf("     Quantite : %d,\n", leStock[i].quantite);
            printf("  },\n");
        }
    }

    printf("}\n");
}

stock creerStock(){
    stock stockVide = MALLOCN(produit, MAX);
    //* Le seul moyen de faire disparaître leStock est d'utiliser la fonction 
    //* free de stdlib
    
    for(int i = 0 ; i < MAX ; i++){
        stockVide[i].ref = 0;
    }

    return stockVide;
}

stock newRef(stock leStock, Nat refereceDuProduit, Nat quantiteDuProduit){
    int i ;
    for( i = 0 ; i < MAX && leStock[i].ref != 0 ; i++);

    if(i == MAX){
        //* On a parcouru tout le tablau et on a pas trouvé
        //* de place vide
        printf("Le stock est plein\n");
        printf("Votre stock est plein. 😔️\n");
    } else {
        leStock[i].ref = refereceDuProduit;
        leStock[i].quantite = quantiteDuProduit;
        printf("Le stock a été bien ajouté👌.\n");
    }

    return leStock;
}

Nat getAmountOfRef(stock leStock){
    // Pre : Le stock n'est pas vide.
    Nat amountOfRef = 0;
    for(int i = 0 ; i < MAX ; i++){
        if( leStock[i].ref != 0){
            amountOfRef++;
        }
    }

    return amountOfRef;
}

Bool existeRef(stock leStock, Nat refAChercher){
    Bool refTrouvee = faux;
    for(int i = 0 ; i < MAX && !refTrouvee ; i++){
        if(leStock[i].ref == refAChercher){
            refTrouvee = vrai;
        }
    }

    return refTrouvee;
}

void deleteRef(stock leStock, Nat refASupprimer){
    // Pré : La reference existe dans le stock
    Bool refTrouvee = faux;
    for(int i = 0 ; i < MAX && !refTrouvee ; i++){
        if(leStock[i].ref == refASupprimer){
            leStock[i].ref = 0;
            refTrouvee = vrai;
        }
    }

}

Nat getQuantityOfRef(stock leStock, Nat refQuantiteChercher){
    //* Pre : La reference existe dans le stock

    Bool refTrouvee = faux;
    Nat quantiteDeLaRef;
    
    for(int i = 0 ; i < MAX && !refTrouvee ; i++){
        if(leStock[i].ref == refQuantiteChercher){
            quantiteDeLaRef = leStock[i].quantite;
            refTrouvee = vrai;
        };
    }

    return quantiteDeLaRef;
}

