#ifndef PILE_CHAR_H
#define PILE_CHAR_H

#include "base.h"

#define MAX_P 50

typedef struct Pile
{
    char tab[MAX_P];
    Nat h;
}pile;

//* Création d'une pile vide
pile pileNouv();

//* Empilement d'un caractère
pile empiler(pile laPile, char leChar);

//* Depilement du sommet de la pile;
pile depiler(pile laPile);

//* Remplacement du sommet de la pile
//* Pré-condition : la pile n'est pas vide
pile remplacer(pile laPile, char nouveauChar);

//* Sommet de la pile
//* Pré-condition : la pile n'est pas vide
char sommetPile(pile laPile);

//* Test si la pile est vide
Bool estPileVide(pile laPile);

//* Hauteur de la pile
Nat hauteur(pile laPile);

char oppose(char unChar);

//*
Bool bienParenthese(char chaine[]);





#endif