#include "base.h"

typedef struct sldc {
    Nat valeur;
    struct sldc *suivant;
    struct sldc *precedent;
}strListe, *liste;

typedef struct {
    liste first; // Premier élément de la liste
    liste cur;   // Élément courant;
    Bool fin;    // Vaut vrai si cur est sur le dernier élément
}strIter, *Iter;

#define foreach(V,L) Iter _I = init(L); for( V = value(_I) ; ! end(_I); next(_I), V = value(_I))

liste listeNouv();

Bool estVideListe(liste laListe);

void afficheListe(liste laListe);

//* Opération en tête de la liste
liste adjonctionEntete(liste laListe, Nat valeurAAjouter);

liste suppressionEnTete(liste laListe);

Nat longueurListe(liste laListe);

Nat accesTete(liste laListe);

Bool appartient(liste laListe , Nat valeur);


//* Opération en i-ème position
Nat accesElementPositionI(liste laListe , Nat position);

//* Insertion ( On a besoin de l'addresse du noeud juste avant la position i)
liste addresseNoeudPositionI(liste laListe, Nat position);

//* Insertion à la position I
liste insertionPositionI(liste laListe, Nat position, Nat valeurAInserer);

//* Changement d'une valeur de la liste
liste changementPositionI(liste laListe, Nat position, Nat nouvelleValeur);

//* Suppression d'une valeur
liste suppressionPositionI(liste laListe, Nat position);

//------------------------------------------------------------------------

Iter init(liste l);
Bool end(Iter i);
Iter next(Iter i);
Iter prev(Iter i);
Nat value(Iter i);

void cherche(liste laListe, Nat valeurAChercher);






//* Fonction d'aide
liste creerListeN(Nat nombreElt);


 