#include <stdio.h>
#include "file.h"

file fileNouv(){
    file fileVide;
    fileVide = MALLOC(strFile);
    fileVide->queue = NULL;
    fileVide->tete = NULL;
     
    return fileVide;
}

file enfiler(file laFile, Nat x){
    //* On crée le noeud
    noeud element = MALLOC(strNoeud);
    if(element == NULL){
        fprintf(stderr, "Erreur : Allocation mémoire");
        exit(EXIT_FAILURE);
    }

    element->valeur = x;
    element->suivant = NULL;
    
    //* Cas simple : File est vide
    if(estfileVide(laFile)){
        laFile->tete = element;
        laFile->queue = element;
    }else{
        //* Cas général
        laFile->queue->suivant = element;
        laFile->queue = element;
    }

    return laFile;
}

Bool estfileVide(file laFile){
    
    return laFile->tete == NULL ;
}

file supprimerTete(file laFile){
    //* Pre : La file est non vide
    //* Cas simple : la file n'a qu'un seul noeud
    if(laFile->queue == laFile->tete){ //* la file n'a qu'un seul noeud
        laFile->queue = NULL;
        laFile->tete = NULL;
    }else {
        noeud eltASupprimer = laFile->tete;
        laFile->tete = laFile->tete->suivant;
        FREE(eltASupprimer);
    }

    return laFile;
}

Nat sommetfile(file laFile){
    //* Pre : File non vide
    return laFile->tete->valeur;
}

Nat longuerFileAux(noeud NoeudTete, noeud noeudQueue){
    return NoeudTete == noeudQueue ? 1 : 1 + longuerFileAux(NoeudTete->suivant, noeudQueue);
}

Nat longeurFile(file laFile){
    if(estfileVide(laFile)){
        return 0;
    } else {
        return longuerFileAux(laFile->tete, laFile->queue);
    }
}

Nat longeurFileIter(file laFile){
    //* long file vide -> 0
    if(estfileVide(laFile)){
        return 0;
    }

    noeud temp;
    Nat compteur = 0;

    for( temp = laFile->tete ; temp ; temp = temp->suivant, compteur++);
    return compteur;
}
