#ifndef _FILE__H 
#define _FILE__H

#include "base.h"

#define MAX_P 50

typedef struct StrListe{
    Nat valeur;
    struct StrListe *suivant;
}strListe, *liste;

liste listeNouv();

Bool estVideListe(liste laListe);

liste adjonctionEnTete(liste laListe, Nat valeurAAjouter);

liste suppressionTete(liste laListe);

Nat teteListe(liste laListe);

Nat longueurListe(liste laListe);

//* Opération sur la queue
liste dernierNoeudListe(liste laListe);

liste adjonctionEnQueue(liste laListe, Nat valeurAAjouter);

Nat queueListe(liste laListe);

liste supressionQueue(liste laListe);



//* Opération sur la première occurence.

//* Rétourne NULL ou l'addresse du noeud trouvé.
liste rechercheNoeud(liste laListe, Nat valeur);


//* Dans la liste, on échange la valeur courante d'un noeud par la nouvelle 
//* valeur. et on a pas besoin de l'addresse du noeud.
liste changement(liste laListe , Nat valeurCourante, Nat nouvelleValeur);


//* Pour supprimer un noeud, on a bésoin de l'addresse du noeud juste avant
liste rechercheNoeudAvant(liste laListe, Nat valeur);

//* Supprime la première occurence d'une liste
liste supprimeFirstOcc(liste laListe, Nat valeurASupprimer);

//* Opérations sur le i-ème élément

void afficheListe(liste laListe);
#endif