#include <stdio.h>
#include <stdlib.h>
#include "liste.h"

int main(){
    liste maListe = listeNouv();

    if(estVideListe(maListe)){
        printf("Liste vide.\n");
    }else {
        printf("Liste non vide.\n");
    }

    // maListe = adjonctionEntete(maListe, 4);
    // maListe = adjonctionEntete(maListe, 5);
    maListe = creerListeN(10);

    if(estVideListe(maListe)){
        printf("Liste vide.\n");
    }else {
        printf("Liste non vide.\n");
    }
    printf("La tete vaut : %d .\n", accesTete(maListe));

    afficheListe(maListe);
    printf("Longueur avant suppression : %d.\n", longueurListe(maListe));

    maListe = suppressionEnTete(maListe);
    printf("Liste après suppression de la tête : ");
    afficheListe(maListe);
    printf("\n");
    printf("Longueur après suppression : %d.\n", longueurListe(maListe));

    if(appartient(maListe, 5)){
        printf("5 appartient à la liste.\n");
    }else {
        printf("5 n'appartient pas à la liste.\n");
    }

    printf("Elt en position 5 : %d\n", accesElementPositionI(maListe, 5));

    printf("\n");
    printf("Insertion de 55 en position 6 :\n");
    maListe = insertionPositionI(maListe, 6, 55);
    printf("La nouvelle liste est : \n");
    afficheListe(maListe);

    printf("\n");
    printf("Remplacement du 1er Noeud par 45.\n");
    maListe = changementPositionI(maListe, 1, 45);
    printf("La nouvelle liste est : \n");
    afficheListe(maListe);
    printf("\n");

    printf("Suppression du 1 er Noeud...\n");
    maListe = suppressionPositionI(maListe, 1);
    printf("La nouvelle liste est : \n");
    afficheListe(maListe);

    printf("On cherche la valeur 84 dans notre liste.\n");
    cherche(maListe, 84);

    printf("Teste de la macro :\n");
    int v;
    foreach(v, maListe) printf("%d", v);

    return 0;
}