#include <stdio.h>
#include <stdlib.h>


//* Mon architecture est de type petit boutiste
//* car il commence par le le bit de poids le plus faible

char d2c (int n){
  return (n<0 ? '?' : (n<10 ? '0'+n : (n<36 ? 'A' + (n-10) : '?')));
}

long long int P2(int n) {
  return 1 << n;
}

// Fonctions à compléter

// Exo 1
void base2(int n) {
    int remainder ;
    int valuesInBase2[20];
    int i;

    for(i = 0; n != 0 ; i++){
        remainder = n % 2;
        n /= 2;  // n = n / 2;
        valuesInBase2[i] = remainder;
    }
    
    int length = i-1; //* Because at the end of the loop, i is incremented
    for( int j = length; j >= 0 ; j--){
        printf("%d", valuesInBase2[j]);
    }
    printf("\n");
}
// Exo 1, question 2
int n_b( char *addr, int i){
    //* Que fait cette fonction?
    //* Elle determine le i-ème bit de la representation en binaire
    //* du caractère à l'addresse *addr;

    char charactere_dans_chaine = addr[i/8]; 
    //* On divise par 8 car chaque caractère est codé sur 8 bits

    // printf("%d\n", charactere_dans_chaine);
    return charactere_dans_chaine >> i%8 & 0x1;
    //* (charactere_dans_chaine >> i%8) & 0x1;
    //* l'operateur >> est prioritaire par rapport à l'operateur &
}

// Exo 3
void baseB(int B, int n){
    if(B>= 1 && B <= 36)
    {
        if( B == 2) 
        {
            base2(n);
        } else 
        {
            int remainder = n % B;
            int quotient  = n / B;
            char valueInBaseB[300] = {d2c(remainder)};
            // printf("%d\n", valueInBase2[0]);
            int i = 1;
            while( quotient != 0 )
            {
                remainder = quotient % B;
                quotient = quotient / B;
                valueInBaseB[i] = d2c(remainder);
                // printf("%d\n", valueInBase2[i]);
                i++;
                // printf("taille = %d\n", i);
            }

            int length = i-1;
            for( int j = length; j >= 0 ; j--)
            {
                printf("%c", valueInBaseB[j]);
            }
            printf("\n");
        }
    }   
}

// Exo 4
void mantisse(float f, int result[]) {
    //* Comment expliquer ce casting?
    for(int i = 0 ; i < 23; i++){
        result[i] = n_b((char*)(&f), i);
    }
}

float mantisseNormalisee(float f){
    int result[23];

    mantisse(f, result);
    float puiss = 1.f / 2.f;
    float m ;
    float mantisse = 1.f;

    for(int i = 0 ; i < 23; i++){
        m = result[i];
        mantisse += m*puiss;
        puiss /= 2.f;
    }

  return mantisse;
}

void exposant(float f, int result[]) {
    for(int j= 0, i = 23 ; i < 31; i++, j++){
        result[j] = n_b((char*)(&f), i);
    }
}

int exposantSansExces(float f) {
    int bitsExposant[8];
    int E = 0;
    int m; 
    exposant(f, bitsExposant);
    
    for(int i = 0 ; i < 8; i++){
        m = bitsExposant[i];
        E += m << i; // <=> m * 2^(i);
    }
    
  return E - 127;
}

int signe(float f) {

  return n_b((char*)(&f), 31);
}

void afficheTableau(int* tab, int taille){
    for(int i = 0 ; i < taille; i++){
        printf("%d  ", tab[i]);
    }
    printf("\n");
}

int main(){
    //base2(3);
    //base2(5);
    //base2(65);
    //baseB(2, 5);
    // baseB(16, 17777);
    // char ch[223] = "BAnjour";
    // printf("%d et %c\n", n_b(ch, 8), n_b(ch, 8));
    // int i = 18;
    // printf("%d\n", 'A' >> i % 8); // Affiche : 0
    // printf("bit : %d\n", ('A' >> i % 8) & 0x1); // Affiche : bit : 1

    // char lettre[2] = {'a', 'b'};
    // for(int i = 0 ; i < 16; i++){
    //     printf("%d  ", n_b(lettre, i));
    // }
    // printf("\n");

    int result[23];
    int bitsExposant[8];
    float floatNumber = 17.7890625;
    mantisse(floatNumber, result);
    afficheTableau(result, 23);
    exposant(floatNumber, bitsExposant);
    afficheTableau(bitsExposant, 8);
    printf("mantisse = %f\n", mantisseNormalisee(floatNumber));
    printf("exposant = %d\n", exposantSansExces(floatNumber));
    printf("bit de signe : %d\n", signe(floatNumber));

  return EXIT_SUCCESS;
}
