#include <stdio.h>
#include "gestionDeStock.h"

void afficherLeStock(stock leStock){
    printf("{\n");
    for(int i = 0 ; i < MAX ; i++ ){
        if(leStock[i].ref != 0){
            printf("  {\n");
            printf("     Reference : %d,\n", leStock[i].ref);
            printf("     Quantite : %d,\n", leStock[i].quantite);
            printf("  },\n");
        }
    }

    printf("}\n");
}

void creerStock(stock leStock){
    //* On initialise toutes nos ref à 0
    for(int i = 0 ; i < MAX ; i++){
        leStock[i].ref = 0;
    }
}

void newRef(stock leStock, Nat refereceDuProduit, Nat quantiteDuProduit){
    int i ;
    for( i = 0 ; i < MAX && leStock[i].ref != 0 ; i++);

    if(i == MAX){
        //* On a parcouru tout le tablau et on a pas trouvé
        //* de place vide
        printf("Le stock est plein\n");
    } else {
        leStock[i].ref = refereceDuProduit;
        leStock[i].quantite = quantiteDuProduit;
        printf("Le produit a été bien ajouté 👌️.\n");
    }

}

Nat getAmountOfRef(stock leStock){
    Nat nbrDeRef = 0;

    for(int i = 0 ; i < MAX ; i++){
        if(leStock[i].ref != 0){
            nbrDeRef++;
        }
    }

    return nbrDeRef;
}

Bool existeRef(stock leStock, Nat refAChercher){
    Bool trouve = faux;

    for(int i = 0 ; i < MAX && !trouve ; i++){
        if(leStock[i].ref == refAChercher)
            trouve = vrai;
    }

    return trouve;
}

void deleteRef(stock leStock, Nat refASupprimer){
    //* Pre : la reference existe dans le stock
    Bool refTrouvee = faux;

    for(int i = 0 ; i < MAX && !refTrouvee; i++){
        if(leStock[i].ref == refASupprimer){
            //* Une fois supprimer, on sort de la boucle
            leStock[i].ref = 0;
            refTrouvee = vrai;
            printf("La reference a été bien supprimer 👌️.\n");
        }
    }
}

Nat getQuantityOfRef(stock leStock, Nat ref){
    //* Pre : La ref existe déjà le stock
    
    Bool refTrouvee = faux;
    Nat quantiteDeLaRef = 0;
    for(int i = 0 ; i < MAX && !refTrouvee ; i++){
        if(leStock[i].ref == ref){
            printf("%d\n", i);
            quantiteDeLaRef = leStock[i].quantite;
            refTrouvee = vrai;
        }
    }
    
    return quantiteDeLaRef;
}
