#ifndef PILE_CHAR_H
#define PILE_CHAR_H

#include "base.h"

#define MAX_P 50

typedef struct StrPile 
{
    Nat tab[MAX_P];
    Nat h1;
    Nat h2;
}strPile, *couplePile;

//* Création d'une pile vide
couplePile pileNouv();

//* Empilement d'un caractère
couplePile coupleEmpiler(couplePile laPile,Nat quellePile,  Nat value);

//* Depilement du sommet de la pile;
couplePile depilerCouple(couplePile laPile, Nat quellePile);

//* Remplacement du sommet de la pile
//* Pré-condition : la pile n'est pas vide
//* pile remplacer(pile laPile, char nouveauChar);

//* Sommet de la pile
//* Pré-condition : la pile n'est pas vide$
Nat sommetPile(couplePile laPile, Nat quellePile);

//* Test si la pile est vide
Bool estPileVide(couplePile laPile, Nat quellePile);

//* Hauteur de la pile
Nat hauteur(couplePile laPile);

//* Somme des éléments de la pile
Nat sommeCouplePile(couplePile laPile , Nat quellePile);

#endif