#include <stdlib.h>
#include "file.h"

File fileNouv(){
    File fileVide;

    fileVide.tete = NULL;
    fileVide.queue = NULL;

    return fileVide;
}

File adjonctionEnQueue(File laFile, Nat valeur){
    noeud newNode = MALLOC(Strfile);

    if(!newNode){
        fprintf(stderr, "Erreur : Allocation échoué.");
        exit(EXIT_FAILURE);
    }

    newNode->v = valeur;
    newNode->s = NULL;

    // Cas simple ( File vide)
    if(estVideFile(laFile)){
        laFile.queue = newNode;
        laFile.tete = newNode ;
    }
    // Cas général (Plus d'un élément)
    else{
        laFile.queue->s = newNode;
        laFile.queue = newNode;
    }

    return laFile;
}

Bool estVideFile(File laFile){
    return laFile.tete == NULL;
}

Nat tete(File laFile){
    // Prè-condition : File non vide
    return laFile.tete->v; 
}

File supressionEnTete(File laFile){
    // Pré-condition  : 
    //      File non vide.

    // Cas simple (1 un seul élément).
    if(laFile.tete == laFile.queue){
        FREE(laFile.tete);
        laFile = fileNouv();
    }
    // Cas général ( Plus d'un élémént)
    else {
        noeud noeudASupprimer = laFile.tete;
        laFile.tete = laFile.tete->s;
        FREE(noeudASupprimer);
    }

    return laFile; 
}

Nat longueurFile(File laFile){
    Nat longueur = 0 ;
    if(estVideFile(laFile)){
        longueur = 0 ;
    }else{
        noeud temp = laFile.tete;
        while(temp != NULL){
            longueur++;
            temp = temp->s;
        }
    }

    return longueur;
}

void afficheFile(File laFile){
    // On commence par la tête
    noeud temp = laFile.tete;
    while(temp != NULL){
        printf("%d  ", temp->v);
        temp = temp->s;
    }
    printf("\n");
}
