//* Pour une mesure de sécurité en plus pour le processeur
#ifndef __FILE_H
#define __FILE_H

#include "base.h"
#define MAX 1000

//* Définition d'une file
//* On considère notre objet étant un Nat
//* Implantation contigue et prog par mutation
//* Simulation du passage par addresse;

typedef struct StrNoeud {
    Nat valeur;
    struct StrNoeud *suivant;
}strNoeud, *noeud;

typedef struct StrFile {
    noeud tete;
    noeud queue;
}strFile, *file;

//* Prototypes

//* Création d'une file vide;
file fileNouv();


//* Emfilement de x
file enfiler(file lafile, Nat x);

//* Test file vide
Bool estfileVide(file lafile);

//* Sommet de la file
Nat sommetfile(file lafile);

//* Suppressin de la tête 
file supprimerTete(file lafile);

//* longueur de la file

Nat longuerFileAux(noeud NoeudTete, noeud noeudQueue);
Nat longeurFile(file laFile);
Nat longeurFileIter(file laFile);


#endif
