//* Pour une mesure de sécurité en plus pour le processeur
#ifndef __PILE_H
#define __PILE_H

#include "base.h"
#define MAX 1000

//* Définition d'une pile
//* On considère notre objet étant un Nat
//* Implantation contigue et prog par mutation
//* Simulation du passage par addresse;

typedef struct StrPile {
    Nat n;
    struct StrPile *suivant;
}strpile, *pile;

//* Prototypes

//* Création d'une pile vide;
pile pileNouv();


//* Empilement de x
pile empiler(pile laPile, Nat x);

//* Test pile vide
Bool estPileVide(pile laPile);

//* Sommet de la pile
Nat sommetPile(pile laPile);

//* Depilement du sommet
pile depiler(pile laPile);

//* hauteur de la pile
Nat hauteurPile(pile laPile);

//* Remplacement du sommet
pile remplacerSommet(pile laPile, Nat y);


#endif
