#include <stdio.h>
#include "base.h"
#include "pile.h" 

int main(){
    pile maPile = pileNouv();

    if(estPileVide(maPile)){
        printf("La pile est vide.\n");
        printf("Hauteur de la pile vaut : %d\n", hauteurPile(maPile));
    }else {
        printf("La pile n'est pas vide.\n");
        printf("Sommet de la pile vaut : %d\n", sommetPile(maPile));
    }

    maPile = empiler(maPile, 4);

    if(estPileVide(maPile)){
        printf("La pile est vide.\n");
    }else {
        printf("La pile n'est pas vide.\n");
        printf("Sommet de la pile vaut : %d\n", sommetPile(maPile));
        printf("Hauteur de la pile vaut : %d\n", hauteurPile(maPile));
    }

    maPile = remplacerSommet(maPile, 5);

    if(estPileVide(maPile)){
        printf("La pile est vide.\n");
        printf("Hauteur de la pile vaut : %d\n", hauteurPile(maPile));
    }else {
        printf("La pile n'est pas vide.\n");
        printf("Sommet de la pile vaut : %d\n", sommetPile(maPile));
    }

    maPile = depiler(maPile);

    if(estPileVide(maPile)){
        printf("La pile est vide.\n");
    }else {
        printf("La pile n'est pas vide.\n");
        printf("Sommet de la pile vaut : %d\n", sommetPile(maPile));
        printf("Hauteur de la pile vaut : %d\n", hauteurPile(maPile));
    }
    
    return 0;
}