#include <stdio.h>
#include "pile.h"

pile pileNouv(){
    pile maPileVide;
    maPileVide.tabDeNat = MALLOCN(Nat, MAX) ;
    maPileVide.taille = MAX;
    maPileVide.nbrDeNat = 0;

    return maPileVide;
}

pile empiler(pile laPile, Nat x){
    //* Si la pile est plein, on réalloue MAX Nat;
    if(laPile.nbrDeNat == laPile.taille){
        Nat *tabDeNatTemp = laPile.tabDeNat;
        Nat nouvelleTailleDeTabNat = laPile.taille + MAX;
        laPile.tabDeNat = REALLOC(laPile.tabDeNat, Nat, nouvelleTailleDeTabNat);

        //* Si la réallocation échoue
        if(laPile.tabDeNat == NULL){
            laPile.tabDeNat = tabDeNatTemp;
        }else {
            laPile.taille = nouvelleTailleDeTabNat;
            laPile.tabDeNat[laPile.nbrDeNat] = x;
            laPile.nbrDeNat++;
        }
    }else {
        laPile.tabDeNat[laPile.nbrDeNat] = x;
        laPile.nbrDeNat++;  
    }

    return laPile;
}

Bool estPileVide(pile laPile){
    return (laPile.nbrDeNat == 0) ? vrai : faux;
}

Nat sommetPile(pile laPile){
    // pre : la pile est non vide
    printf("%d\n", laPile.nbrDeNat);
    return laPile.tabDeNat[laPile.nbrDeNat - 1];
    
}

pile depiler(pile laPile){
    // pre : la pile est non vide
    laPile.nbrDeNat = laPile.nbrDeNat - 1;
    
    return laPile;
}

Nat hauteurPile(pile laPile){
    return laPile.nbrDeNat;
}

pile remplacerSommet(pile laPile, Nat y){
    //* pre : laPile est non vide 
    return empiler(depiler(laPile), y);
}